
/*
 * Arff.java
 *
 * Created on May 24, 2005, 11:07 PM
 */
/*
 * Arff.java
 *
 * Created on February 23, 2004, 11:40 AM
 */

package datamining;


import java.io.File;
import java.io.*;
import javax.swing.*;
import java.awt.Container;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 *
 * @author  redmond
 */
public class Arff {
    
    /** Creates a new instance of Arff */
    public Arff() {
    }
    
    /** 
     * get started with a file - including choosing it using the FileChooser,
     * making sure we can read from it
     */
    public static BufferedReader startFile () throws IOException {
        
        //////////////////////////////
        // set up for reading file
        //////////////////////////////
        JFrame empty = new JFrame(); // just create as GUI container so can use file chooser
        Container dummy = empty.getContentPane();
        JFileChooser files;
        String filename;
        File filehandle;
        FileReader fReader;
        BufferedReader bReader;
        String line;
        StringTokenizer tokenizer;
        empty.setVisible(true);  // display empty JFrame
        files = new JFileChooser();   
        // start open file dialog box
        int result = files.showOpenDialog(dummy);
        if (result == 0) {
            // if successful, read the file
            filename = files.getSelectedFile().getPath();
            filehandle = files.getSelectedFile();
            // check if can read
            if (filehandle.exists() && filehandle.canRead() ) {
                // try to read it
                    fReader = new FileReader(filehandle);
                    bReader = new BufferedReader(fReader);
                    line = bReader.readLine(); 
                    // first line needs to be relation or comment
                    while ( line.startsWith("%" ) ){
                        line = bReader.readLine();
                    }
                    // ought to be @relation now
                    if (! line.startsWith("@relation")){
                        System.out.println("Not a proper arff file, exiting");
                        System.exit(0);
                    }
                    else {
                        System.out.println("reading relation line: " + line);
                    }
            }
            else {
                throw new IOException(); // signal that we are unable to handle the file
            }
        }
        else {
            throw new IOException(); // signal that we are unable to handle the file
        }
        return bReader;
    }
    
    /**
     * read all attribute info from an ARFF file
     * Depends on Attribute class
     */
    public static Vector readAttributes (BufferedReader bReader) throws IOException {
        Vector attributes = new Vector(10);
        String line;
        // get all attribute info - read until reach data
        line = bReader.readLine();
        while (! line.startsWith("@data") ) {
            // check if an attribute line
            if (line.startsWith("@attribute") ) {
                System.out.println("reading an attribute line: " + line);
                Attribute latest = new Attribute(line); // create attribute from line
                // avoid adding numeric attribute
                if (latest.getName().equals("numeric")) {
                    System.out.println("attribute skipped: " + line);
                }
                else {
                    attributes.add(latest); // add to vector of attributes
                    System.out.println("Attribute created: " + latest);
                }
            }
            line = bReader.readLine();
        }
        return attributes;
    }
    
    
    
    /**
     * read all instance info from an ARFF file
     * Depends on Attribute and Instance classes
     */
    public static Vector readInstances (BufferedReader bReader, Vector attributes) throws IOException {
        Vector allInstances = new Vector(10);
        String line;
        // now ready to read data                                           
        line = bReader.readLine();
        int numAtt = attributes.size();
        // read until end of file
        while (line != null) {
            System.out.println("data line: " + line); 
            Instance newInstance = new Instance(numAtt, line);
            allInstances.add(newInstance);
            System.out.println("Instance created: " + newInstance);
            line = bReader.readLine();
        }           
        return allInstances;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
    }
    
}
