/*
 * Instance.java
 *
 * Created on May 24, 2005, 11:11 PM
 */

/*
 * Instance.java
 *
 * Created on February 23, 2004, 12:39 AM
 */

package datamining;

import java.util.StringTokenizer;

/**
 *
 * @author  mike
 */
public class Instance {
    
    private String [] values;
    
    /** Creates a new instance of Instance */
    public Instance() {
    }
    
    /** Creates a new instance of Instance  - given the size */
    public Instance(int size) {
        values = new String[size];
    }
    
    /** Creates a new instance of Instance  - given an array of String */
    public Instance(String [] vals) {
        values = new String[vals.length];
        for (int i = 0; i < vals.length; i++ ) {
            values[i] = vals[i];
        }
    }
    
    /** Creates a new instance of Instance  - given a number of attributes and a String */
    public Instance(int numAtt, String line) {  
        values = new String[numAtt]; 
        // take care of the data in this record
        StringTokenizer tokenizer = new StringTokenizer(line,",");
        for (int att = 0; att < numAtt; att++) {
            String val = tokenizer.nextToken();
            values[att] = val;
        }
    }
    
    /** 
     * report value for Nth attribute
     */
    public String getNthValue ( int n) {
        // really ought to protect self against bad n
        return values[n];
    }
    
    /** 
     * report value for last attribute - generally the class - so deserves extra special treatment
     */
    public String getLastValue ( ) {
        int last = values.length - 1;
        return values[last];
    }
    
    /**
     * Report whether a given value for a given attribute number is found in the invoking instance
     */
    public boolean isAttributeMatch (String val, int indx) {
        if (values[indx].equals(val) ) {
            return true;
        }
        else {
            return false;
        }
    }
    
    /** 
     * produce a string representation for the Instance
     */
    public String toString() {
        String res = "";
        for (int i = 0; i < values.length; i++) {
            res += " " + values[i] + " ";
        }
        return res;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
    }
    
}

