/*
 * Main.java
 *
 * Created on July 14, 2005, 11:12 AM
 * Intended to try to pull out stuff from SGA project to try to get jar file to run
 */

package sgapowerunit;

import java.io.File;
import java.io.*;
import javax.swing.*;
import java.awt.Container;
import java.util.StringTokenizer;
import java.util.Vector;
import datamining.*;
import IO.*;

/**
 *
 * @author Mike
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        Vector attributes = new Vector(10);
        Vector attributesSecondMethod = new Vector(10);
        //Vector allInstances = new Vector(10);
        
        PrintWriter tracefile = null;
        
        
        // read in info about power units and required capacity - and build a PowerUnitProblemSpecificInfo
        // the number of power units read in better match the number of attributes read in
        // out to inform the user what kind of file we are searching for
        
        PowerUnitProblemSpecificInfo problemInfo = null; // new PowerUnitProblemSpecificInfo();
        //////////////////////////////
        // set up for reading file with info about power units
        //////////////////////////////
        try {
            BufferedReader extraReader = ExtraInput.startFile();
            /// ### prob read this file here too - power unit class should probably help with this
            problemInfo = new PowerUnitProblemSpecificInfo(extraReader); 
        }
        catch (IOException ex) {
            System.out.println("Error while reading extra file, exiting");
            System.exit(0);
        }
        //attributesSecondMethod = problemInfo.buildAttributes();
        attributes = problemInfo.buildAttributes();
        // just for debugging show all attributes 
        System.out.println("Attributes (second method): ");
        //for (int at = 0; at < attributesSecondMethod.size(); at++) {
        for (int at = 0; at < attributes.size(); at++) {
            //System.out.println("     " + attributesSecondMethod.get(at));
            System.out.println("     " + attributes.get(at));
        }
        //System.exit(0);  // just dump out when testing attribute creation
        
        //////////////////////////////
        // set up for writing trace file
        //////////////////////////////
        try {
            tracefile = Trace.startTraceFile();
        }
        catch (IOException ex) {
            System.out.println("Error while preparing trace file, exiting");
            System.exit(0);
        }
        
        // MAR 05/25/05 - get parameter values from user - would really like to do with real GUI
        int populationSize = 20;
        int cycles = 10;
        double pMutate = .01;
        try { 
            populationSize = RedmondMsgIn.readValidIntRobust("How many rules in population?", 2, 500);
            cycles = RedmondMsgIn.readValidIntRobust("How many generations to train?", 1, 500);
            pMutate = RedmondMsgIn.readValidDoubleRobust("How likely is a mutation?", 0.0, 1.00);
        }
        catch( UserCancelException ex) {
            // I think if they skipped out of any of the questions then they wanted to quit
            System.exit(0);
        }
        
        System.out.println("Assumptions:");
        System.out.println("      Population Size:         " + populationSize);
        System.out.println("      Generations:             " + cycles);
        System.out.println("      Probability of Mutation: " + pMutate);
        
        System.out.println("A total of " + Solution.howManyPossibleSolutions(attributes) + " potential hypotheses exist");
        
        if (tracefile != null) {
            tracefile.println("Problem info:");
            tracefile.println(problemInfo);
            tracefile.println("");
            tracefile.println("Assumptions:");
            tracefile.println("      Population Size:         " + populationSize);
            tracefile.println("      Generations:             " + cycles);
            tracefile.println("      Probability of Mutation: " + pMutate);
            tracefile.println("");

            tracefile.println("A total of " + Solution.howManyPossibleSolutions(attributes) + " potential hypotheses exist");
            tracefile.println("");
            
        }

            
        Vector trainingSolutions = SGADesignProb.Train(attributes, populationSize, cycles, pMutate, problemInfo, tracefile);

           
        tracefile.close();

                
        System.exit(0);
    }
    
}
