/*
 * PowerUnit.java
 *
 * Created on July 14, 2005, 11:20 AM
 */

/*
 * PowerUnit.java
 * For Power Plant maintanance domain
 *
 * Created on July 6, 2005, 2:28 PM
 */

package sgapowerunit;

/**
 *
 * @author Mike
 */
public class PowerUnit {
    
    int unitNumb = 0;
     
    int unitCapacity = 10;
    
    int numIntervalsForMaint = 1;
    
    /** Creates a new instance of PowerUnit */
    public PowerUnit() {
    }
    
    /** Creates a new instance of PowerUnit */
    public PowerUnit(int unit, int capac, int interv) {
        unitNumb = unit;
        unitCapacity = capac;
        numIntervalsForMaint = interv;
    }
    
    /**
     * report unit number
     */
    public int getUnitNumb () {
        return unitNumb;
    }
    
    
    /**
     * report unit power generating capacity
     */
    public int getUnitCapacity () {
        return unitCapacity;
    }
    
    /**
     * report unit number of intervals needed for maintenance
     */
    public int getNumIntervalsForMaint () {
        return numIntervalsForMaint;
    }
    
    /**
     * change the unit number
     */
    public boolean setUnitNumb (int unit) {
        unitNumb = unit;
        return true;   // for now - any unit is ok
    }
    
    /**
     * change the unit capacity
     */
    public boolean setUnitCapacity (int capac) {
        if (capac > 0) {
            unitCapacity = capac;
            return true;
        }
        else {
            return false;
        }
    }
    
    /**
     * change the unit intervaqls for maint
     */
    public boolean setNumIntervalsForMaint (int interv) {
        if ((interv > 0) && (interv < 4)) { // must have maintenance, but can't be out all year
            numIntervalsForMaint = interv;
            return true;
        }
        else {
            return false;
        }
    }
    
    public String toString() {
        String res = "";
        res += this.getUnitNumb() + ",";
        res += this.getUnitCapacity() + ",";
        res += this.getNumIntervalsForMaint();
        return res;
    }
}